<?
	/*****************************************************************************
	* Disclaimer:																 *
	*	THERE IS NO WARRANTY FOR THE PROGRAM. THE COPYRIGHT HOLDERS AND/OR       *
	*	OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND,  *
	*	EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED  *
	*	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.      *
	*	THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH *
	*	YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL      *
	*	NECESSARY SERVICING, REPAIR OR CORRECTION.								 *
	******************************************************************************
	
	*******************************************************************************
	* Installation instructions:												  *
	*	1. Save this file (CWIncPayJunction.php) in /cw3/CWLibrary/ProcessPayment/*
	*	2. Open /application.php												  *
	*		Make the following changes. Edit Lines 48 and 49:					  *
	*		Line 48: $cwGlobalSettings->paymentAuthType = "gateway";			  *
	*		Line 49: $cwGlobalSettings->paymentAuthName = "CWIncPayJunction.php"; *
	*******************************************************************************

	******************************************************************************************************************************
	* Tips:                                                                                                                      *
	*   1. For testing purposes, by default, the variable $server (line 58 below) is set to point to                             *
	*      the Demo server: https://www.payjunctionlabs.com/quick_link/                                                          *
	*                                                                                                                            *
	*      To process LIVE transactions, please update the variable $server (line 58 below) to point to                          *
	*      the Live server: https://www.payjunction.com/quick_link/                                                              *
	* 																		                                                     *
	*	2. For testing purposes, by default, the field dc_logon (line 69 below) is set to the test account (pj-ql-01).           * 
	*      To run live transactions that go to your account, you must change the login to YOUR QuickLink login.					 *							                           *
	*	                                                                                                                         *
	*   3. For testing purposes, by default, the field dc_password (line 70 below) is set to the test account (pj-ql-01p).       *
	*      To run live transactions that go to your account, you must change the password to YOUR QuickLink password.            *                                                            	*                                                                                                                            *
	*   HOW TO FIND YOUR LIVE QUICK LINK LOGIN AND PASSWORD:                                                                     *
	*      http://www.payjunction.com/trinity/support/view.action?knowledgeBase.knbKnowledgeBaseId=589                           *				     								                                  
	*																			                                                 *
	*	NOTE:																	                                                 *
	*	  If you are using the Demo server, and Test Login and Password, you can see your transactions via the Demo account.     *					                                                 	*	  To login to the PayJunction test account:								                                                 *
	*	       1. Go to www.payjunctionlabs.com										                                             *
	*	       2. Click on "Merchant Login" (top, right side of webpage)				                                         *
	*	       3. Login: payjunctiondemo  Password: demo123								                                         *
	*	       4. To view your transactions, go to "Batches/History", then "View Current Batch", in the top menu of the account. *
	******************************************************************************************************************************
		
	/****************************************************** 
	Configuration values 
	*******************************************************/
	
	//$debugEmails = true;
	$companyEmail = $_SESSION["CompanyEmail"];
	$developerEmail = $_SESSION["DeveloperEmail"];
	$company = $_SESSION["CompanyName"];

	
	$curlpath = "/usr/bin/curl";
	
	$server   = "https://www.payjunctionlabs.com/quick_link";
	
	$expmonth = substr($ccExprDate, 0, -4);
	
	$expyear = substr($ccExprDate, -2);	
	
	
	/****************************************************** 
	Setup keys and values
	*******************************************************/
	$post_array = array(
		"dc_logon" => "pj-ql-01",
		"dc_password" => "pj-ql-01p",
		"dc_transaction_amount" => $_SESSION["orderTotal"],
		"dc_first_name" => $row_rsCWGetCustBilling["cst_FirstName"],
		"dc_last_name" => $row_rsCWGetCustBilling["cst_LastName"],
		"dc_number" =>  $ccNumber,
		"dc_expiration_month" => $expmonth,
		"dc_expiration_year" => $expyear,	
		"dc_verification_number" => $ccV,
		"dc_address" => $row_rsCWGetCustBilling["cst_Address1"],
		"dc_city" => $row_rsCWGetCustBilling["cst_City"],
		"dc_state" => $row_rsCWGetCustBilling["stprv_Name"],
		"dc_zipcode" => $row_rsCWGetCustBilling["cst_Zip"],
		"dc_country" => $row_rsCWGetCustBilling["country_Code"],
		"dc_transaction_type" => "AUTHORIZATION_CAPTURE",
		"dc_test" => "No",
		"dc_version" => "1.2"
	);

	/****************************************************** 
	Prepare the POST string to be sent to the PayJunction Server 
	*******************************************************/
	
	$request = "";
	foreach ($post_array as $key => $val) {
	  	$request .= $key . "=" . urlencode($val) . "&";
	}
	$request = substr($request, 0, -1);
	
	
	
	/****************************************************** 
	Connect and send POST string to PayJunction Server, store reponse in $content
	*****************************************************/
	
			$ch = curl_init($server);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $request);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			$content = curl_exec($ch);
		
			$curl_errno = curl_errno($ch);
			$curl_error = curl_error($ch);
			curl_close($ch);

	
	/******************************************** 
	Parse the response from PayJunction
	********************************************/
	$content = explode(chr (28), $content); // The ASCII field seperator character is the delimiter
	foreach ($content as $key_value) {
		list ($key, $value) = explode("=", $key_value);
		$response[$key] = $value;
	}

	/******************************************** 
	Display the appropriate response
	********************************************/
	if (strcmp ($response['dc_response_code'], "00") == 0 || strcmp ($response['dc_response_code'], "85") == 0) { // 00 and 85 are transaction approved codes.
		
		$transactionResult = "Approved"; //Cartweaver Var
		$orderStatusID = 2;	//Cartweaver Var
		/*
		
		echo "<center><font color=red>Your payment was processed succesfully</font></center><br><br>";
		echo "Your Payment Details<br><br>";
		echo "Response Code: ".$response['dc_response_code']."<br>";
		echo "Name: ".$response['dc_card_name']."<br>";
		echo "Card Number: ".$response['dc_card_number']."<br>";
		echo "Card Address : ".$response['dc_card_address']."<br>";
		echo "City : ".$response['dc_card_city']."<br>";
		echo "Zip Code : ".$response['dc_card_zipcode']."<br>";
		echo "Total : ".$response['dc_base_amount']."<br>";
		
		*/
	} else if ($response['dc_response_code']) { // Output the response code and message
		
		$transactionResult = "Failed"; //Cartweaver Var
		/*
		
		echo "<center><font color=red>Your payment did not process successfully</font></center><br><br>";
		echo "Transaction Details<br><br>";
		echo "Response Code: ".$response['dc_response_code']."<br>";
		echo "Response Message: ".$response['dc_response_message']."<br>";
		
		*/
	} else if ($curl_errno) {  // If curl had an error, output the error code and message.
		
		/*
		
		echo "<center><font color=red>Your payment did not process successfully</font></center><br><br>";
		echo "Transaction Details<br><br>";
		
echo "Curl error code: $curl_errno <br>"
		echo "Curl message: $curl_error <br>";
		
		*/
	
	} else {
		$transactionResult = "Failed"; //Cartweaver Var
		$orderStatusID = 0; // Cartweaver Var
		
		/*
	
		echo "<center><font color=red>Your payment did not process successfully</font></center><br><br>";
		echo "Transaction Details<br><br>";
		echo "An unknown error has occured.<br>";
		
		*/
	
	}
?>
